/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                :    7 09:10:03 MSD 2004
    copyright            : (C) 2004 by root
    email                : vaulter@nm.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/poll.h> 

#include <netinet/in.h>
#include <errno.h>
#include <signal.h>

//options
extern char OPT_LOGFILE[255];
extern char OPT_OPTFILE[255];
extern char OPT_PIDFILE[255];
extern int OPT_PORT;//default
extern char OPT_ALLOWLIST[255];
extern char OPT_DEBUGFILE[255];//if passed from arguments

static struct sockaddr_in addr;
static struct sockaddr_in remoteaddr;//
int need2exit = 0;//flag for exit from while cycle
//termsignal handler
static void sgn_term(int signno)
{
    signal(SIGTERM,SIG_IGN);
   need2exit=1;
   print2log("SIGNAL: terminate detected");

}



int main(int argc, char *argv[])
{
	FILE* fpid;
	FILE* fst;
	FILE* shellprog;
	int insocket;
	int acsocket=0;//socket for connection
    char buff[700]; //buffer for stat string
    int pos=0;//
	int sock_len=sizeof(remoteaddr);
    //fill structs for poll
    struct pollfd wsocks[1];//we have one socket
	int pollres=0;

//parse arguments

	if(argc>1)//some exists
	{
		int i;
		for(i=1;i<argc;i++)
		{
			if(argv[i][0]=='-')//option!
			{
				switch(argv[i][1])
				{
					case 'o':
					//config file
						strcpy(OPT_OPTFILE,&argv[i][3]);//skip space character
					break;
					case 'd':
					//debug file
						strcpy(OPT_DEBUGFILE,&argv[i][3]);
					break;

				}
			}
		}

	}
	if(!parse_options(OPT_OPTFILE))
		return 0;
	load_allow(OPT_ALLOWLIST);//load allow list from file
  open_log();
  //printf("VaultSoft ProcMon\n");
  //signals
  signal(SIGTERM,sgn_term);
   //determinate parent process
   //if we run NOT under 'init' process
   if(getppid()!=1)
   {
    int fres=fork();
    if(fres==-1)
    {//ERROR
      print2log("ERROR: can't fork: %s",strerror(errno));
      close_log();
      return 1;
    }
    if(fres!=0)
    {//we are not child process! we cannot work?
      //print2log("INFO: exit for fork");
      return 0;
    }
    setsid();
   }
   //
   	print2log("INFO: VaultSoft RemoteProcMon just started");
   //write pidfile
	fpid=fopen(OPT_PIDFILE,"wt");
   	if(fpid)
   	{
   		fprintf(fpid,"%u\n",getpid());
		fclose(fpid);
	}

  if(insocket=OpenSocket(OPT_PORT))//5000 - post by default
  {
    print2log("INFO: socket for listen opened at port %d",OPT_PORT);

    wsocks[0].fd=insocket;
    wsocks[0].events=POLLIN;//we would wait for incoming events
    wsocks[0].revents=0;
    while(!need2exit)
    {
      memset(&remoteaddr,0,sock_len);//zero filling
      //wait poll for a 100 ms then proceed
      if(!need2exit && (pollres=poll((struct pollfd*)&wsocks,(unsigned int)1,100))==-1)
      {//error occured
        print2log("ERROR: can't poll: %s", strerror(errno));
        need2exit=1;//exit from while
      }
      //check if we have events from poll
      if((pollres>0) && (wsocks[0].revents & POLLIN))
      {//have some
        if(-1 != (acsocket = accept(insocket,(struct sockaddr*)&remoteaddr,&sock_len)))
        {
          //print2log("INFO: Connection accepted from %s, socket #%d",inet_ntoa(remoteaddr.sin_addr),acsocket);
          //send to client current proc busy
		  //check for allowance
			strcpy(buff,(char*)inet_ntoa(remoteaddr.sin_addr));
			if(-1 == check_allow(buff))
			{//dis
				print2log("WARNING: connection from %s refused - not in allowlist",inet_ntoa(remoteaddr.sin_addr));
			}
		else
		{
          fst=fopen("/proc/stat","rt");
          if(!fst)
          {
            print2log("ERROR: cannot open /proc/stat: %s",strerror(errno));
            memset(buff,0,sizeof(buff));
          }
          else
          {
            fgets(buff,sizeof(buff),fst);
            pos=strlen(buff);//shift current position
            //buff[strlen(buff)-1]=0;// carriage return to zero symbol
            fclose(fst);
          }

          // memory info
          fst=fopen("/proc/meminfo","rt");
          if(!fst)
          {
            print2log("ERROR: cannot open /proc/meminfo: %s",strerror(errno));
            memset(buff,0,sizeof(buff));
          }
          else
          {
            fgets(&buff[pos],sizeof(buff)-pos,fst);
            fgets(&buff[pos],sizeof(buff)-pos,fst);//second line
            pos=strlen(buff); //shift position
            fgets(&buff[pos],sizeof(buff)-pos,fst);//third line append to buff
            //buff[strlen(buff)-1]=0;// carriage return to zero symbol
            fclose(fst);
          }
			//read df
			shellprog=popen("df","r");
			if(!shellprog)
			{
				print2log("ERROR: cannot open df: %s", strerror( errno ));
			}
			else
			{
				//skip first line
				pos=strlen(buff);//end of string
				fgets(&buff[pos],sizeof(buff)-pos,shellprog);
				while(!feof(shellprog))
				{//read all lines
					fgets(&buff[pos],sizeof(buff)-pos,shellprog);
					pos=strlen(buff);
				}
				pclose(shellprog);
			}
          if(send(acsocket,buff,strlen(buff),0)==-1)
            //print2log("SUCCESS: Data sended to client");
            print2log("ERROR: Data for mem doesn't sended to client: %s", strerror( errno ));
          //send memory info
         }
          close(acsocket);

        } //accept
        else
          print2log("ERROR: can't accept connection: %s",strerror( errno ));
      }//polls
    }//while
    

  }
  else
  {
//        print2log("ERROR: %s",strerror( errno ));
        return 0;//failed
  }
  close(insocket);
  unlink(OPT_PIDFILE);
  print2log("INFO: Exit");
  close_log();
 
  return EXIT_SUCCESS;
}


int OpenSocket(int port)
{// return 0 if failed 1 if success
	int opt = 1;
  	int sock=socket(AF_INET,SOCK_STREAM,0);
  if(sock==-1)
  {
    print2log("ERROR: Socket creation failed");
    return 0;
  }
  else
    print2log("SUCCESS: Socket was created: %d",sock);
    //setting socket properties
	if( setsockopt( sock, SOL_SOCKET, SO_REUSEADDR, & opt, sizeof( opt ) ) == -1 )
	{
	    print2log( "ERROR: Call to setsockopt failed (port: %i): %s", port, strerror( errno ) );
	    close( sock );
        return 0;
     }


    // initialize data for socket listening...
    addr.sin_family = AF_INET;
    addr.sin_addr.s_addr = INADDR_ANY;
    addr.sin_port = htons( port );

    if( bind( sock, (struct sockaddr*) &addr, sizeof( addr ) ) == -1 )
    {
    	print2log( "ERROR: Error binding socket (port: %i): %s", port, strerror( errno ) );
    }

    
  if(listen(sock,5)==-1)//5 max incoming connection
  {
    print2log("ERROR: Set to listen state failed");
    return 0;
  }
  else
    print2log("SUCCESS: Socket set to listen state");

  return sock;

  

}






